@version 2.2
@warnings
@strict
@script modeler
@name "MF Merge Weights"

var weightMapNames = nil;
var weightMapList = nil;
    
main
{
	selmode(USER);
	var weightMap = VMap(VMWEIGHT);
    while(weightMap)
    {
        if(weightMap.type == VMWEIGHT)
        {
            weightMapList += weightMap;
            weightMapNames += weightMap.name;
        }
        weightMap = weightMap.next();
    }
    
    var weightMapName = "";
    foreach(weightMapName, weightMapNames)
    {
    	var stringArray = split(weightMapName);
		if(stringArray[4] != nil) // nil, nil, name, .x
    	{
    		// We have something with a .x name ending
    		MergeMap(weightMapName, stringArray[3]);
    	}
    }
}

MergeMap: sourceMapName, destinationMapName
{
	var sourceMapIndex = FindIndexOfMap(sourceMapName);
	var destinationMapIndex = FindIndexOfMap(destinationMapName);
	
    var destinationWeightMap  = weightMapList[destinationMapIndex];
    var sourceWeightMap = weightMapList[sourceMapIndex];
    
    var p = 0;
    
    editbegin();
    
    foreach(p, points)
    {    
        var sourceValue = sourceWeightMap.getValue(p);
        if(sourceValue == nil) // if value not assigned
        {
        	sourceValue += 0.0; // set it to 0 for this point
        }	
        var destinationValue = destinationWeightMap.getValue(p);
        if(destinationValue == nil)
        {
        	destinationValue += 0.0;
        }
		sourceValue[1] += destinationValue[1];
		destinationWeightMap.setValue(p,sourceValue);
		sourceWeightMap.setValue(p,nil);
    }
    editend();
}

FindIndexOfMap: mapName
{
	var arraySize = sizeof(weightMapNames);
	var i = 1;
	for(i = 1; i <= arraySize; i++)
	{
		if(mapName == weightMapNames[i])
		{
			return i;
		}
	}
}
