@version 2.2
@warnings
@script generic
@name "MF Unity Rig"

var bonesList;
var selectedItem;

generic
{
	selectedItem = Scene().firstSelect();
	if (!selectedItem.isMesh())
    {
        error("Please select an object.");
        return;
	}

	oldalert = Scene().alertlevel;
	AlertLevel(3);
	AutoConfirm(true);
	
	ClearAllBones();
	
	// Create bones from skelegons and iterate through them
	SkelegonsToBones();
	var bone = selectedItem.bone();
	var i=1;
	while(bone)
	{
        SelectItem(bone.id);
        var containsBracket = strright(bone.name,1);
		var isItTheFirstItem = strright(bone.name,3);

        if(containsBracket != ")" || isItTheFirstItem == "(1)")
		{
			var boneName = bone.name;
			if(isItTheFirstItem == "(1)") // Strip (1) from bone name
			{
				boneName = strsub(boneName, 1, (sizeof(boneName) - 4));
			}
 			bonesList[i][1] = boneName;
 			bonesList[i][2] = bone.getWorldPosition(0);
 			
 			var parentName = bone.parent.name;
			if(strright(parentName,1) == ")") // Strip (x) from parent name
			{
				parentName = strsub(parentName, 1, (sizeof(parentName) - 4));
			}
			bonesList[i][3] = parentName;
			
			i++;
		}
		bone = bone.next();
		
	}

	// Delete the skelegons
	ClearAllBones();
	
	// Create bones for the stripped down Unity rig
	var rootBone;
	var n = 1;
	for(n = 1; n < i; n++)
	{
		var boneName = bonesList[n][1];
		//var containsBracket = strright(boneName,1);
		var isItTheFirstItem = strright(boneName,3);
		//if(containsBracket != ")" || isItTheFirstItem == "(1)")
		//{
			if(isItTheFirstItem == "(1)")
			{
				boneName = strsub(boneName, 1, (sizeof(boneName) - 4));
			}
			AddBone(boneName);
			BoneWeightMapName(boneName);
			BoneWeightMapOnly();
			BoneNormalization();
			BoneStrength(0);
			BoneStrengthMultiply();
			BoneRestLength(0.05);
			AddPosition(bonesList[n][2].x, bonesList[n][2].y, bonesList[n][2].z);

			if(boneName=="Hips")
			{
				rootBone = Scene().firstSelect();
			}			
		//}
	}
	
	RefreshNow();
	
	//firstBone = selectedItem.bone();
	bone = selectedItem.bone();
	i=1;
	while(bone)
	{
        SelectItem(bone.id);
		if(bone.name == "Hips")
		{
			//ParentItem(selectedItem.id);
			BoneActive();
			RecordRestPosition();
			
		}
		else
		{
		    //error(bone.name + " - " + bonesList[i][3]);
			var parentBone = GetParentBone(bonesList[i][3]);
			SelectItem(bone.id);
			ParentItem(parentBone.id);
			BoneActive();
			RecordRestPosition();
		}
		bone = bone.next();
		i++;
	}

	SelectItem(selectedItem.id);
	
	AutoConfirm(false);
    AlertLevel(oldalert);
    
    //info(bonesList[1][2]);
}

GetParentBone: parentName
{	
	var bone = selectedItem.bone();
	while(bone)
	{
        SelectItem(bone.id);
 		if(bone.name == parentName)
 		{
 			return bone;
 		}
		bone = bone.next();
	}
}